/*
  Pachanga Protocols => trycky . trycky@7a69ezine.org OAA . 1/11/2001

  V01 libnet : http://www.packetfactory.net
  V02 libnet & libpcap : http://www.tcpdump.org && http://www.packetfactory.net
  
  http://www.7a69ezine.org 

  Compilacion en Linux => make linux
  Compilacion en *BSD  => make bsd

Para la V02 :

- Intercalar accion de un ICMP con otro .
- Hacer uso de libpcap para recivir y hacer analisis .
- Implementar peticiones ARP .
- Fingerprinter S.O via ICMP .

*/

#ifdef bsd
#include <sys/sockio.h>
#include <sys/ioctl.h>
#endif

#ifdef linux
#include <sys/ioctl.h>
#endif 

#include <libnet.h>

#define version "Pachanga Protocols V01 . trycky <trycky@7a69ezine.org> OAA"

#define IP_UCHAR_COMP(x, y) \
    (x[0] == y[0] && x[1] == y[1] && x[2] == y[2] && x[3] == y[3])

#ifdef linux
u_char *d_ifaz="eth0";
#endif
#ifdef bsd
u_char *d_ifaz="ne3";
#endif

void uso(char *,int tos,int icmp,int igmp,int redirect);
void coge_valor(char *ifaz,int ip,int mac,int netmask,int broad);
void bucle();

void envia_icmp_echo(int r);
void envia_icmp_mask(void);
void envia_icmp_ts(void);
void envia_icmp_redirect();
void envia_icmp_unreach(void);

void envia_igmp();

void envia_tcp();
void envia_udp();

void puertos(int num);
void estadisticas(void);
void muere(int tipo);

u_char eth_src[6]= {0x0d,0x0e,0x0a,0x0d,0x00,0x00}; // Direccion MAC de origen
u_char eth_dst[6]= {0xff,0xff,0xff,0xff,0xff,0xff}; // Dirrecion MAC de destino

struct argumentos{
  int spoof_mac;   // Spoof de MAC
  int aumenta_pkt; // En caso de rellenar paquete
  int v;           // Para el modo verbose 
  int frag;        // Activa la fragmentacion
  int retraso;     // usleep()
  int r_total;     // Total del retraso
  int tcp;         // Valores a tomar para el bucle()
  int udp;
  int icmp;
  int redirect;
  int igmp;
  int arp;
  int TOS;
} args;

struct paquete{
  int TTL;
  int TOS;
  u_short ip_frag;
  int size;
  int id;
  int ip_ver; 
  char *i_header;
  int i_tipo;
  int igmp_t;
  int redirect_t;
  u_short igmp_q;
  u_short redirect_q;
  u_short s_port;
  u_short d_port;
} pkt;

struct libnet_link_int *network;
struct libnet_ethernet_hdr *p;
struct libnet_arp_hdr *a;

char err_buf[LIBNET_ERRBUF_SIZE];

u_char *packet,*device=NULL;
u_long src_ip=0,dst_ip=0;           
u_int32_t IPNM,IPBR; // NETMASK , BROADCAST

char d_ip[128],s_ip[128];
int tam_pkt,fd,total_pkt=1,total,pkt_loss,pkt_yeah;
char protocolo[4];

int main(int argc,char *argv[])
{
  int x,M;
  u_int d[6];
  
  if(argc==1) {
    printf("%s\n",version);
    printf("Uso : %s -h \n",argv[0]);
    exit(EXIT_SUCCESS); 
  } 
  
  // Protocolos :
  args.tcp=0;
  args.udp=0;
  args.icmp=0;
  args.redirect=0;
  args.igmp=0;

  // Componemos las cabezeras :
  pkt.ip_frag="IP_DF";
  pkt.TOS=0;
  pkt.TTL=255;
  pkt.id=getpid();
  pkt.i_tipo=0;
  pkt.igmp_t=0;
  pkt.redirect_t=0;
  pkt.ip_ver=4;
  pkt.s_port=0;
  pkt.d_port=0;

  // Signals :
  signal(SIGINT,muere);
  signal(SIGTERM,muere);
  signal(SIGHUP,muere);

  // Banner
  printf("%s\n",version);

  while (( x=getopt(argc,argv, "p:r:o:d:i:t:c:m:T:R:S:l:I:UufVvh")) != EOF) {
      switch(x){
      case 'h':
	uso(argv[0],0,0,0,0);
	break;
      case 'r':
	args.retraso=1;
	args.r_total=atoi(optarg);
	break;
      case 'o':
	if(!(src_ip=libnet_name_resolve(optarg, LIBNET_RESOLVE))) {
	  libnet_error(LIBNET_ERR_FATAL,"IP origen incorrecta :%s\n",optarg); }
	strncpy(&s_ip,optarg,128);
	break;
      case 'f':
	args.frag=1;
	pkt.ip_frag="IP_MF";
	break;
      case 'd':
        if(!(dst_ip=libnet_name_resolve(optarg, LIBNET_RESOLVE))) {
	  libnet_error(LIBNET_ERR_FATAL,"IP destino incorrecta :%s\n",optarg);}
	strncpy(&d_ip,optarg,128);
        break;
      case 'i':
	device=(char*)optarg; break;
	break;
      case 't':
        if(!strcmp("help",optarg)) {
          uso(argv[0],0,1,0,0);
        }
	pkt.i_tipo=(int)atoi(optarg);
	args.icmp=1;
	strncpy(protocolo,"ICMP",4);
	break;
      case 'c':
	total_pkt=atoi(optarg);
	break;
      case 'm':
      M=sscanf(optarg,"%x:%x:%x:%x:%x:%x",&d[0],&d[1],&d[2],&d[3],&d[4],&d[5]);
      if(M!=6){printf("MAC no valida.\n");exit(EXIT_SUCCESS);}
      for(M=0;M<6;M++){eth_src[M]=d[M];}
      args.spoof_mac=1;
      break;
      case 'T':
	args.TOS=1;
	if(!strcmp("help",optarg)) {
	  uso(argv[0],1,0,0,0); 
	}
	switch(atoi(optarg)){
	case 10:
	  pkt.TOS=10;
	  break;
	case 8:
	  pkt.TOS=8;
	  break;
	case 4:
	  pkt.TOS=4;
	  break;
	case 2:
	  pkt.TOS=2;
	  break;
	}
	break;
      case 'S':
	pkt.size=atoi(optarg);
	break;
      case 'l':
	pkt.TTL=atoi(optarg);
        if(pkt.size>=255){
	  printf("El valor del TTL no puede ser superior a 255.\n"); 
	  pkt.TTL=255; }
	break;
      case 'R':
        if(!strcmp("help",optarg)) {
          uso(argv[0],0,0,0,1);
        }
	pkt.redirect_t=atoi(optarg);
	if(pkt.redirect_t>=5 || !pkt.redirect_t){
	  printf("Codigo para el ICMP REDIRECT no valido [%d]\n %s -R help\n",pkt.redirect_t,argv[0]);
	  exit(0);
	}
	switch(pkt.redirect_t){
	case 1: pkt.redirect_q=ICMP_UNREACH_HOST; break;
	case 2: pkt.redirect_q=ICMP_UNREACH_NET; break;
	case 3: pkt.redirect_q=ICMP_UNREACH_PROTOCOL; break;
	case 4: pkt.redirect_q=ICMP_UNREACH_PORT; break;
	}
        strncpy(protocolo,"ICMP",4);
	args.redirect=1;
        break;
      case 'I':
        if(!strcmp("help",optarg)) {
          uso(argv[0],0,0,1,0);
        }
	pkt.i_tipo="I";
	pkt.igmp_t=atoi(optarg);
	if(pkt.igmp_t>=5){
	  printf("Codigo de IGMP no valido [%d]\n %s -h\n",pkt.igmp_t,argv[0]);
	exit(0); } if(!pkt.igmp_t) {
	 printf("Codigo de IGMP no valido [%d]\n %s -h\n",pkt.igmp_t,argv[0]); 
	 exit(0); } 
	switch(pkt.igmp_t){
	case 1: pkt.igmp_q=IGMP_MEMBERSHIP_QUERY; break;
	case 2: pkt.igmp_q=IGMP_V1_MEMBERSHIP_REPORT; break;
        case 3: pkt.igmp_q=IGMP_V2_MEMBERSHIP_REPORT; break;
        case 4: pkt.igmp_q=IGMP_LEAVE_GROUP; break; }
	args.igmp=1;
	strncpy(protocolo,"IGMP",4);
	break;
      case 'U':
	args.udp=1;
	strncpy(protocolo,"UDP",3);
	break;
      case 'u':
	args.tcp=1;
	strncpy(protocolo,"TCP",3);
	break;
      case 'p':
	//        pkt.d_port=(u_short)atoi(optarg);
	puerto(atoi(optarg));
	/*        if(!args.udp || !args.tcp){
          printf("Opcion -p no valida con conexiones que no sean TCP u UDP\n");
	  exit(0); } */
        break;
      case 'v':
	args.v=1;
	break;
      case 'V':
	printf("%s\n",version); 
	exit(EXIT_SUCCESS);
      default:
	uso(argv[0],0,0,0,0);
      }
  }

  if(device==NULL){
    printf("No se ha especificado ninguna interfaz usando : %s\n",d_ifaz);
    strncpy(device,d_ifaz,strlen(d_ifaz));
  }

  if(!src_ip) coge_valor(device,0,1,0,0);
  if(!dst_ip) uso(argv[0],0,0,0,0);
  if(!args.tcp && !args.udp && !args.icmp && !args.igmp && !args.arp){
    printf("No has especificado ningun tipo de conexion\n %s -h\n",argv[0]);
    exit(EXIT_FAILURE); } 

  if(getuid()!=0){
    printf("Tienes que ser root.\n");
    exit(EXIT_FAILURE); }

  if(args.spoof_mac){
    printf("PICMP : %s to (%s:%s) Spoof MAC : %02X:%02X:%02X:%02X:%02X:%02X =>\n",protocolo,d_ip,device,eth_src[0],eth_src[1],eth_src[2],eth_src[3],eth_src[4],eth_src[5]);
  }else{
    printf("PICMP : %s to (%s:%s) =>\n",protocolo,d_ip,device);
  }

  // Comprobamos que se puede abrir el interfaz 
  if((network=libnet_open_link_interface(device,err_buf)) == NULL ) {
    libnet_error(LIBNET_ERR_FATAL,"libnet_open_link_interface: %s\n",err_buf);}

  if(args.icmp){
    if(pkt.i_tipo==3) envia_icmp_unreach(); else
      if(pkt.i_tipo==0) envia_icmp_echo(0); else
	if(pkt.i_tipo==8)  envia_icmp_echo(1); else
	  if(pkt.i_tipo==5) {
	    if(!args.redirect){
     printf("Has de especificar un tipo el paquete  : %s -R help",argv[0]);
     exit(EXIT_FAILURE);
	    }
	    envia_icmp_redirect(); 
	  } else
	    if(pkt.i_tipo==13) envia_icmp_ts(); else 
	      if(pkt.i_tipo==18) envia_icmp_mask(); else 
	    printf("Tipo de ICMP [%d] no valido\n %s -h\n",pkt.i_tipo,argv[0]);
  }
  if(pkt.i_tipo=="I") envia_igmp(); else
    if(args.tcp) envia_tcp(); else
      if(args.udp) envia_udp(); else
	  //	printf("Tipo de Conexion no valida\n %s -h\n",argv[0]);
	  
	  exit(EXIT_SUCCESS);
}

void genera_clase()
{

} 

void envia_icmp_echo(int r)
{
  tam_pkt=LIBNET_IP_H + LIBNET_ETH_H + LIBNET_ICMP_ECHO_H + pkt.size ;

  if(libnet_init_packet(tam_pkt,&packet) == -1){
    libnet_error(LIBNET_ERR_FATAL,"libnet_init_packet : Error.\n"); }

  libnet_build_ethernet(eth_dst,eth_src,ETHERTYPE_IP,NULL,0,packet);

  libnet_build_ip(LIBNET_ICMP_ECHO_H, 0, pkt.id, 0, 0xfff, IPPROTO_ICMP, src_ip, dst_ip, NULL, 0, packet + LIBNET_ETH_H);

  if(r)  libnet_build_icmp_echo(ICMP_ECHO ,0 ,pkt.id ,0xffffffff ,NULL, 0, packet + LIBNET_ETH_H + LIBNET_IP_H);      
  if(!r) libnet_build_icmp_echo(ICMP_ECHOREPLY ,0 ,pkt.id ,0xffffffff ,NULL, 0, packet + LIBNET_ETH_H + LIBNET_IP_H);

 if(libnet_do_checksum(packet+ ETH_H, IPPROTO_ICMP, LIBNET_ICMP_ECHO_H) == -1){
      libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }
  if (libnet_do_checksum(packet + ETH_H, IPPROTO_IP, LIBNET_IP_H) == -1) {
      libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }

  for(total=1;total<=total_pkt;total++){ bucle(); }

  if(libnet_close_link_interface(network) == -1){
   libnet_error(LN_ERR_WARNING,"No se pudo cerrar el interfaz.\n"); }

  libnet_destroy_packet(&packet); 
  return (fd==-1?0:1);
}

void envia_icmp_ts(void)
{
  tam_pkt=LIBNET_IP_H + LIBNET_ETH_H + LIBNET_ICMP_TS_H + pkt.size;
 
 if(libnet_init_packet(tam_pkt,&packet) == -1){
    libnet_error(LIBNET_ERR_FATAL,"libnet_init_packet : Error.\n"); }
  
 libnet_build_ethernet(eth_dst,eth_src,ETHERTYPE_IP,NULL,0,packet);

  libnet_build_ip(LIBNET_ICMP_TS_H, 0, pkt.id, 0, 0xfff, IPPROTO_ICMP, src_ip, dst_ip, NULL, 0, packet + LIBNET_ETH_H);
  
  libnet_build_icmp_timestamp(ICMP_TSTAMP, 0, pkt. id, 0, 0x00000000, 0x00000000, 0x00000000, NULL, 0, packet + LIBNET_ETH_H + LIBNET_IP_H);
  
  if(libnet_do_checksum(packet+ ETH_H, IPPROTO_ICMP, LIBNET_ICMP_TS_H) == -1){
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }
  if (libnet_do_checksum(packet + ETH_H, IPPROTO_IP, LIBNET_IP_H) == -1) {
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }
  
  for(total=1;total<=total_pkt;total++){ bucle(); }
  
  if(libnet_close_link_interface(network) == -1){
    libnet_error(LN_ERR_WARNING,"No se pudo cerrar el interfaz.\n"); }

  libnet_destroy_packet(&packet); 
  return (fd==-1?0:1); 
}

void envia_icmp_mask(void)
{
  tam_pkt=LIBNET_IP_H + LIBNET_ETH_H + LIBNET_ICMP_MASK_H + pkt.size;

  if(libnet_init_packet(tam_pkt,&packet) == -1){
    libnet_error(LIBNET_ERR_FATAL,"libnet_init_packet : Error.\n"); }

  libnet_build_ethernet(eth_dst,eth_src,ETHERTYPE_IP,NULL,0,packet);

  libnet_build_ip(LIBNET_ICMP_MASK_H, 0, pkt.id, 0, 0xfff, IPPROTO_ICMP, src_ip, dst_ip, NULL, 0, packet + LIBNET_ETH_H);
  libnet_build_icmp_mask(ICMP_MASKREPLY, 0,pkt.id, 0, 0xff, NULL, 0, packet + LIBNET_ETH_H + LIBNET_IP_H);

  if(libnet_do_checksum(packet+ ETH_H, IPPROTO_ICMP, LIBNET_ICMP_TS_H) == -1){
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }
  if (libnet_do_checksum(packet + ETH_H, IPPROTO_IP, LIBNET_IP_H) == -1) {
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }

  for(total=1;total<=total_pkt;total++){ bucle(); }

  if(libnet_close_link_interface(network) == -1){
    libnet_error(LN_ERR_WARNING,"No se pudo cerrar el interfaz.\n"); }
  
  libnet_destroy_packet(&packet);
  
  return (fd==-1?0:1);
}

void envia_icmp_redirect()
{
  tam_pkt=LIBNET_IP_H + LIBNET_ETH_H + LIBNET_ICMP_REDIRECT_H + pkt.size;

  if(libnet_init_packet(tam_pkt,&packet) == -1){
    libnet_error(LIBNET_ERR_FATAL,"libnet_init_packet : Error.\n"); }

  libnet_build_ethernet(eth_dst,eth_src,ETHERTYPE_IP,NULL,0,packet);

  libnet_build_ip(LIBNET_ICMP_REDIRECT_H, 0, pkt.id, 0, 0xfff, IPPROTO_ICMP, src_ip, dst_ip, NULL, 0, packet + LIBNET_ETH_H);

  /*
    3 - IP del Gateway 
    4 - Longitud del pkt IP
    5 - IP TOS
    6 - IP id  
    7 - IP frag
    8 - IP TTL
    9 - IP protocol
   10 - IP origen 
   11 - IP destino
   12 - 
   13 -
   14 - Tamao del pkt total
  */

 libnet_build_icmp_redirect(pkt.redirect_q, 0, dst_ip,LIBNET_IP_H , pkt.TOS, pkt.id, pkt.ip_frag, pkt.TTL, pkt.ip_ver, src_ip, dst_ip, 0, 0, packet + LIBNET_ETH_H + LIBNET_IP_H);

  if(libnet_do_checksum(packet+ ETH_H, IPPROTO_ICMP, LIBNET_ICMP_TS_H) == -1){
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }
  if (libnet_do_checksum(packet + ETH_H, IPPROTO_IP, LIBNET_IP_H) == -1) {
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }

  for(total=1;total<=total_pkt;total++){ bucle(); }

  if(libnet_close_link_interface(network) == -1){
    libnet_error(LN_ERR_WARNING,"No se pudo cerrar el interfaz.\n"); }

  libnet_destroy_packet(&packet);

  return (fd==-1?0:1);
}

void envia_icmp_unreach(void)
{
  tam_pkt=LIBNET_IP_H + LIBNET_ETH_H + LIBNET_ICMP_UNREACH_H + pkt.size ;

  if(libnet_init_packet(tam_pkt,&packet) == -1){
    libnet_error(LIBNET_ERR_FATAL,"libnet_init_packet : Error.\n"); }

  libnet_build_ethernet(eth_dst,eth_src,ETHERTYPE_IP,NULL,0,packet);

  libnet_build_ip(LIBNET_ICMP_UNREACH_H, 0, pkt.id, 0, pkt.TTL, IPPROTO_ICMP, src_ip, dst_ip, NULL, 0, packet + LIBNET_ETH_H);

  libnet_build_icmp_unreach(ICMP_UNREACH_SRCFAIL,0,LIBNET_IP_H, 0, pkt.id, 0,pkt.TTL, IPPROTO_ICMP, src_ip, dst_ip, 0, 0,packet + LIBNET_ETH_H + LIBNET_IP_H);

  if(libnet_do_checksum(packet+ ETH_H, IPPROTO_ICMP, LIBNET_ICMP_TS_H) == -1){
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }
  if (libnet_do_checksum(packet + ETH_H, IPPROTO_IP, LIBNET_IP_H) == -1) {
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }

  for(total=1;total<=total_pkt;total++){ bucle(); }

  if(libnet_close_link_interface(network) == -1){
    libnet_error(LN_ERR_WARNING,"No se pudo cerrar el interfaz.\n"); }

  libnet_destroy_packet(&packet);

  return (fd==-1?0:1);
}

void envia_igmp()
{
  tam_pkt=LIBNET_IP_H + LIBNET_ETH_H + LIBNET_IGMP_H + pkt.size ;

  if(libnet_init_packet(tam_pkt,&packet) == -1){
    libnet_error(LIBNET_ERR_FATAL,"libnet_init_packet : Error.\n"); }

  libnet_build_ethernet(eth_dst,eth_src,ETHERTYPE_IP,NULL,0,packet);

  libnet_build_ip(LIBNET_IGMP_H, 0, pkt.id, 0, pkt.TTL, IPPROTO_IGMP, src_ip, dst_ip, NULL, 0, packet + LIBNET_ETH_H);
 libnet_build_igmp(pkt.igmp_q, 0, dst_ip, NULL, 0,packet + LIBNET_ETH_H + LIBNET_IP_H);

 if(libnet_do_checksum(packet+ ETH_H, IPPROTO_IGMP, LIBNET_IGMP_H) == -1){
   libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }
 if (libnet_do_checksum(packet + ETH_H, IPPROTO_IP, LIBNET_IP_H) == -1) {
   libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }

 for(total=1;total<=total_pkt;total++){ bucle(); }

  if(libnet_close_link_interface(network) == -1){
    libnet_error(LN_ERR_WARNING,"No se pudo cerrar el interfaz.\n"); }

  libnet_destroy_packet(&packet);

  return (fd==-1?0:1);
}

void envia_tcp()
{
  tam_pkt=LIBNET_IP_H + LIBNET_TCP_H + LIBNET_ETH_H + pkt.size;

  if(libnet_init_packet(tam_pkt,&packet) == -1){
    libnet_error(LIBNET_ERR_FATAL,"libnet_init_packet : Error.\n"); }

  libnet_build_ethernet(eth_dst,eth_src,ETHERTYPE_IP,NULL,0,packet);
  
  libnet_build_ip(LIBNET_TCP_H, pkt.TOS, pkt.id, 0, pkt.TTL, IPPROTO_TCP, src_ip, dst_ip, NULL, 0, packet + LIBNET_ETH_H);
  libnet_build_tcp(pkt.s_port, pkt.d_port, 0xa1d95, 0x53, TH_SYN, 1024, 0, NULL, 0, packet + LIBNET_IP_H + LIBNET_ETH_H);

  if(libnet_do_checksum(packet+ ETH_H, IPPROTO_TCP, LIBNET_TCP_H) == -1){
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }
  if (libnet_do_checksum(packet + ETH_H, IPPROTO_IP, LIBNET_IP_H) == -1) {
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }

  for(total=1;total<=total_pkt;total++){ bucle(); }

  if(libnet_close_link_interface(network) == -1){
    libnet_error(LN_ERR_WARNING,"No se pudo cerrar el interfaz.\n"); }

  libnet_destroy_packet(&packet);

  return (fd==-1?0:1);
}

void envia_udp()
{
  tam_pkt=LIBNET_UDP_H + LIBNET_TCP_H + LIBNET_ETH_H + pkt.size;

  if(libnet_init_packet(tam_pkt,&packet) == -1){
    libnet_error(LIBNET_ERR_FATAL,"libnet_init_packet : Error.\n"); }

  libnet_build_ethernet(eth_dst,eth_src,ETHERTYPE_IP,NULL,0,packet);

  libnet_build_ip(LIBNET_TCP_H, pkt.TOS, pkt.id, 0, pkt.TTL, IPPROTO_TCP, src_ip, dst_ip, NULL, 0, packet + LIBNET_ETH_H);
  libnet_build_udp(pkt.s_port, pkt.d_port, NULL, 0, packet + LIBNET_IP_H+LIBNET_ETH_H);

  if(libnet_do_checksum(packet+ ETH_H, IPPROTO_UDP, LIBNET_UDP_H) == -1){
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }
  if (libnet_do_checksum(packet + ETH_H, IPPROTO_IP, LIBNET_IP_H) == -1) {
    libnet_error(LIBNET_ERR_FATAL, "libnet_do_checksum failed\n"); }

  for(total=1;total<=total_pkt;total++){ bucle(); }

  if(libnet_close_link_interface(network) == -1){
    libnet_error(LN_ERR_WARNING,"No se pudo cerrar el interfaz.\n"); }

  libnet_destroy_packet(&packet);

  return (fd==-1?0:1);
}

// Fijar a 1 las variables a devolver :
void coge_valor(char *ifaz,int mac,int ip,int netmask,int broad)
{
  struct ifreq eth;
  
#ifdef bsd
  struct sockaddr_in netmask;
#endif bsd

  int fd=socket(AF_INET,SOCK_DGRAM,0);

 if(ifaz==NULL){ printf("Interfaz: %s no valida.\n",ifaz); exit(EXIT_FAILURE);}

  strcpy(eth.ifr_name,ifaz);
  
if(mac){
#ifdef linux
  if(ioctl(fd,SIOCGIFHWADDR,&eth) < 0){
    perror("ioctl()"); }
  memcpy(eth_src,eth.ifr_hwaddr.sa_data,6);
#endif
}

if(ip){
  if(ioctl(fd,SIOCGIFADDR,&eth) < 0){
    perror("ioctl()"); }
  memcpy(&src_ip,&eth.ifr_addr.sa_data[2],4); 
}

if(netmask){
  if(ioctl(fd,SIOCGIFNETMASK,&eth) < 0){
    perror("ioctl()"); }
#ifdef linux
  memcpy(&IPNM,&eth.ifr_netmask.sa_data[2],4); 
#endif
#ifdef bsd
  netmask.sin_addr=((struct sockaddr_in *)&eth.ifr_addr)->sin_addr;
#endif
}
 
 if(broad){
   if(ioctl(fd,SIOCGIFBRDADDR,&eth) < 0){
     perror("ioctl()"); }
   memcpy(&IPBR,&eth.ifr_broadaddr.sa_data[2],4); 
}

 close(fd);
 return 0;
}

void puerto(int puerto)
{
  int x=0;
  if(puerto >= 65536 || puerto==0 ){
    printf("El valor %d a la opcion de <-p> va desde 1 a 65535.\n",puerto);
    exit(EXIT_FAILURE);
  }
    pkt.d_port=(u_short)puerto;
}

void estadisticas(void)
{
  printf("\n");
  printf("-- picmp estadisticas => %s --\n",d_ip);
  printf("paquetes enviados : %d. paquetes perdidos : %d.\n",total,pkt_loss);
  return;
}

void bucle()
{
  for(total=1;total<=total_pkt;total++) {
    if((fd=libnet_write_link_layer(network,device,packet,tam_pkt)) < tam_pkt)
      {
	libnet_error(LN_ERR_WARNING,"Error paquete=%d Solo se pudieron mandar: %d bytes.\n",total,fd);
	pkt_loss++;
      }
    else{ 
      if(args.icmp | args.igmp){
	if(args.v) {
	  printf("[%d] bytes hacia=> %s paquete=%d TTL=%d TOS=%d\n",fd,d_ip,total,pkt.TTL,pkt.TOS); 
	  pkt_yeah++;
	}
	if(!args.v) {
	  printf("[%d] bytes hacia=> %s paquete=%d\n",fd,d_ip,total); 
	  pkt_yeah++; 
	}
      }
      if(args.tcp | args.udp){
	if(args.v) {
	  printf("[%d] bytes hacia=> %s:%d paquete=%d TTL=%d TOS=%d\n",fd,d_ip,pkt.d_port,total,pkt.TTL,pkt.TOS);
	  pkt_yeah++;
	}
	if(!args.v) {
  printf("[%d] bytes hacia=> %s:%d paquete=%d\n",fd,d_ip,pkt.d_port,total);
  pkt_yeah++;
	}
      }
      if(args.retraso){
	usleep(args.r_total); }
    }
  }
  estadisticas();
}

void muere(int tipo)
{
  switch(tipo){
  case SIGINT:
    printf("Signal SIGINT recivida chapando.\n");
    break;
  case SIGTERM:
    printf("Signal SIGTERM recivida chapando.\n");
    break;
  case SIGHUP:
    printf("Signal SIGHUP recivida chapando.\n");
    break;
  default:
    printf("Error en picmp chapando.\n");
    break;
  }
  estadisticas();
  exit(EXIT_SUCCESS);
}

void aborta(char *m)
{
  if(!strcmp("aborta",m)) {
  }

  exit(EXIT_FAILURE);
}

void uso(char *a,int tos,int icmp,int igmp,int redirect)
{
  if(tos==1){
    printf(
	   "    TOS NAME            VALOR\n"
	   "  ============          =====\n"
	   "   Minimum Delay          10 \n"
	   "   Maximum Throughput      8 \n"
	   "   Maximum Reliability     4 \n"
	   "   Minimum Cost            2 \n\n");  
    exit(EXIT_SUCCESS); 
  }

  if(icmp==1){
    printf(
	   "NUM\tTIPO DE ICMP\n"
	   "===\t============\n"
	   "<0>\tICMP_ECHO_REPLY\n"
	   "<3>\tICMP_UNREACH\n"
	   "<5>\tICMP_REDIRECT\n"
	   "<8>\tICMP_ECHO_REQUEST\n"
	   "<13>\tICMP_TIMESTAMP\n"
	   "<18>\tICMP_MASKREPLY\n\n");
    exit(EXIT_SUCCESS);
  }

  if(igmp==1){
    printf(
	   "NUM\tTIPO DE IGMP\n"
	   "===\t============\n"
	   "<1>\tIGMP_MEMBERSHIP_QUERY\n"
	   "<2>\tIGMP_V1_MEMBERSHIP_REPORT\n"
	   "<3>\tIGMP_V2_MEMBERSHIP_REPORT\n"
	   "<4>\tIGMP_LEAVE_GROUP\n\n");
    exit(EXIT_SUCCESS);
  }

  if(redirect==1){
    printf(
	   "NUM\tTIPO DE ICMP_REDIRECT\n"
           "===\t============\n"
	   "<1>\tICMP_UNREACH_NET\n"
           "<2>\tICMP_UNREACH_HOST\n"
           "<3>\tICMP_UNREACH_PROTOCOL\n"
           "<4>\tICMP_UNREACH_PORT\n\n");
    exit(EXIT_SUCCESS);
  }
  
  printf("\n%s OAA!!\n",version);
  printf("Uso : %s\n",a);
  printf("-o\tIp Origen\n");
  printf("-d\tDestino\n");
  printf("-i\tInterfaz <eth0>\n");
  printf("-r\tRetraso de espera al mandar\n");
  printf("-t\tTipo de ICMP a enviar : -t help\n");
  printf("\t<0> ICMP_ECHO_REPLY\t<3> ICMP_UNREACH\n");
  printf("\t<5> ICMP_REDIRECT\t<8> ICMP_ECHO_REQUEST\n");
  printf("\t<13> ICMP_TIMESTAMP\n");
  printf("\t<18> ICMP_MASKREPLY\n");
  printf("-R\tEspecifica el tipo de ICMP REDIRECT : -R help\n");
  printf("-c\tTotal de paquetes a mandar\n");
  printf("-m\tPara hacer Spoof de MAC\n");
  printf("-S\tTamao del paquete a mandar\n");
  printf("-T\tFijar el valor del TOS. Para ver los valores : -T help\n");
  printf("-l\tFijar el valor del TTL ""time to live""\n");
  printf("-I\tEnvia un paquete IGMP tipos : -I help\n");
  printf("\t<1> IGMP_MEMBERSHIP_QUERY\t<2> IGMP_V1_MEMBERSHIP_REPORT\n");
  printf("\t<3> IGMP_V2_MEMBERSHIP_REPORT\t<4> IGMP_LEAVE_GROUP\n");
  printf("-u\tEspecifica conexion usando TCP\n");
  printf("-U\tEspecifica conexion usando UDP\n");
  printf("-p\tEspecifica el puerto solo en TCP & UDP\n");
  printf("-v\tModo Verbose\n");
  printf("-V\tMuestra la version\n");
  exit(EXIT_SUCCESS);
}
